Monday, March 19, 2012

Using ObjectOverrule To Prevent Entity Being Changed

Kean Walmsley has a post on using ObjectOverrule to prevent entity being erased. The solution is surprisingly simple: simply throw an Exception in the overridden Erase() method of the ObjectOverrule. Well, it simple only someone (Kean Walmsley and Stephen Preston) let you know that you can do this.
Well, it turns out that we can do the same thing in ObjectOverrule.Open() method to prevent entity being changed.
Here I show some code first and then discuss some interesting issues with this approach.

Let's assume some scenario: a drawing has a particular block inserted, say, a title block with certain attribute. Once the block is inserted and its attribute value is set, we do not want user to change it at all; or it should only be changed programmatically so the attribute value would be kept in sync with data in CAD data source, such as enterprise production database. In my code, the ObjectOverrule will be only applicable to a BlockReference entity if the block reference has an attribute tagged as "ABC".

Here is the code of the ObjectOverrule:

Code Snippet
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.DatabaseServices;
  3. using Autodesk.AutoCAD.Runtime;
  4. using Autodesk.AutoCAD.EditorInput;
  5.  
  6. namespace EntityModifiedOverrule
  7. {
  8.     public class EntChangeVetoOverrule : ObjectOverrule
  9.     {
  10.         private static EntChangeVetoOverrule _instance = null;
  11.         private bool _overruling;
  12.  
  13.         private EntChangeVetoOverrule()
  14.         {
  15.             _overruling = Overrule.Overruling;
  16.         }
  17.  
  18.         public static EntChangeVetoOverrule Instance
  19.         {
  20.             get
  21.             {
  22.                 if (_instance == null)
  23.                     _instance = new EntChangeVetoOverrule();
  24.  
  25.                 return _instance;
  26.             }
  27.         }
  28.  
  29.         public void StartOverrule()
  30.         {
  31.             Overrule.AddOverrule(RXClass.GetClass(
  32.                 typeof(BlockReference)), this, false);
  33.             Overrule.Overruling = true;
  34.  
  35.             //This is required in order for
  36.             //overridden IsApplicable() being used
  37.             //as custom overrule filter
  38.             this.SetCustomFilter();
  39.         }
  40.  
  41.         public void StopOverrule()
  42.         {
  43.             Overrule.RemoveOverrule(
  44.                 RXClass.GetClass(typeof(BlockReference)), this);
  45.             Overrule.Overruling = _overruling;
  46.         }
  47.  
  48.         #region override virtue methods
  49.  
  50.         public override bool IsApplicable(RXObject overruledSubject)
  51.         {
  52.             BlockReference bref = overruledSubject as BlockReference;
  53.  
  54.             if (bref == null)
  55.                 return false;
  56.             else
  57.             {
  58.                 bool isTarget = false;
  59.                 using (Transaction tran = bref.Database.
  60.                     TransactionManager.StartOpenCloseTransaction())
  61.                 {
  62.                     foreach (ObjectId id in bref.AttributeCollection)
  63.                     {
  64.                         var attr = (AttributeReference)tran.GetObject(
  65.                             id, OpenMode.ForRead);
  66.                         if (attr.Tag.ToUpper() == "ABC")
  67.                         {
  68.                             isTarget = true;
  69.                             break;
  70.                         }
  71.                     }
  72.  
  73.                     tran.Commit();
  74.                 }
  75.  
  76.                 return isTarget;
  77.             }
  78.         }
  79.  
  80.         public override void Open(DBObject dbObject, OpenMode mode)
  81.         {
  82.             Editor ed =
  83.                 Application.DocumentManager.MdiActiveDocument.Editor;
  84.  
  85.             if (mode == OpenMode.ForWrite)
  86.             {
  87.                 ed.WriteMessage("\nEntity open for writing: {0}. Denied!",
  88.                     dbObject.GetType().Name);
  89.                 throw new Autodesk.AutoCAD.Runtime.Exception(
  90.                     ErrorStatus.NotApplicable);
  91.             }
  92.             else
  93.             {
  94.                 base.Open(dbObject, mode);
  95.             }
  96.         }
  97.  
  98.         #endregion
  99.     }
  100. }


Here is the code to turn the ObjectOverrule on or off:

Code Snippet
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.Runtime;
  3. using Autodesk.AutoCAD.EditorInput;
  4.  
  5. [assembly: CommandClass(typeof(EntityModifiedOverrule.MyCommands))]
  6.  
  7. namespace EntityModifiedOverrule
  8. {
  9.     class MyCommands
  10.     {
  11.         private static bool _myOverruleOn = false;
  12.  
  13.         [CommandMethod("MyOV")]
  14.         public static void MyCmd()
  15.         {
  16.             Document doc = Autodesk.AutoCAD.ApplicationServices.
  17.                 Application.DocumentManager.MdiActiveDocument;
  18.             Editor ed = doc.Editor;
  19.  
  20.             if (!_myOverruleOn)
  21.             {
  22.                 EntChangeVetoOverrule.Instance.StartOverrule();
  23.                 ed.WriteMessage("\nVeto Entity Modifying Overrule is on\n");
  24.                 _myOverruleOn = true;
  25.             }
  26.             else
  27.             {
  28.                 EntChangeVetoOverrule.Instance.StopOverrule();
  29.                 ed.WriteMessage("\nVeto Entity Modifying Overrule is off\n");
  30.                 _myOverruleOn = false;
  31.             }
  32.         }
  33.     }
  34. }


The IsApplicable() method is used as custom filter for this ObjectOverrule. In my code, it makes sure the Overrule only applies to a block reference that has an attribute with tag being "ABC". Obviously, one can override IsApplicable method with whatever suitable logic to filter out desirable targeting entities to apply custom Overrule.
As one would notice, in the overridden Open() method, I test the OpenMode parameter, and only when the Open method is called in "ForWrite" mode, an Exception is thrown, which effectively aborted the call to Open(), thus, prevent the entity being modified. The the Exception's construction, I use ErrorStatus.NotApplicable as the constructor's argument, but it can be any other ErrorStatus enum value.

When running the code, I can see, the block can be selected/highlighted, its information shows correctly in the property window. Trying to change something with the block, such attribute value in either attribute editing window, or in property window, nothing would happen. I also cannot erase/move/rotate... the block.

However, there is one thing that is annoying me: if I try to move the block, the block is simply disappeared on the screen. Although I can tel it is still there, but not visible, until I issue "REGEN" command. Of course, the block is still there, not moved, thanks to the Overrule.

Another interesting thing I tried is place nothing in Open method but the "throw...." statement. That is, the Overrule simply prevents any sort of opening regardless the "OpenMode". In this case, the filtered entity (the block with attribute tagged with "ABC" in my case) is simply not selectable, thus, no change can be made to it. Obviously, in this case, the applicable entity will not shown up in property window (since it is not selectable), nor the usual AutoCAD tooltip and/or Quick Properties window would also not shown when the cursor hovers on the entity.

Since my code set custom filter to apply the Overrule only to BlockReference entity, there is a side-effect that may crash AutoCAD: when start AutoCAD's built-in command "INSERT". The reason of the crash, I guess, is due to the the fact that the block has attribute and the command does the process in 2 steps: first a block reference is created and added into current space; then the block reference is opened to in order to add attribute reference. It is the second steps causes the crash because the overrule prevent the block reference object from being opened. So, if you wants to use ObjectOverrule to prevent entity being modified, you need to very carefully consider all possible situations that your Overrule could result in something unintentionally. In my case, I could write my own code to insert the specific block that the Overrule applies to.

Lastly, using ObjectOverrule to prevent entity from being change could be very confusing to untrained CAD user. So, targeted users should be very well informed on this behaviour of your custom CAD tool. Also, the CAD tool with such Overrule should be very well planned as how and when the Overrule is loaded/turned on/off.

There is one thing to be aware of with this "throw an exception" in overriden Open() method approach: you cannot test if your Overrule works or not in Visual Studio's' debugging mode. When the line of code that throws the exception runs, Visual Studio treats the exception as unhandled (as it should), thus the debuggung process stops. One can only test this type of Overrule in normal AutoCAD session without Visual Studio's debugging process attached..

No comments:

Followers

About Me

My photo
After graduating from university, I worked as civil engineer for more than 10 years. It was AutoCAD use that led me to the path of computer programming. Although I now do more generic business software development, such as enterprise system, timesheet, billing, web services..., AutoCAD related programming is always interesting me and I still get AutoCAD programming tasks assigned to me from time to time. So, AutoCAD goes, I go.